'
'	Copyright  1990 - 2001 Theodore William Bouskill.
'	This work may be reproduced and redistributed, in whole or in part, without
'	alteration and without prior written permission, solely by educational
'	institutions for nonprofit administrative or educational purposes provided
'	all copies contain the following statement:
'	"Copyright  1990 - 2001 Theodore William Bouskill.
'	This work is reproduced and distributed with the permission of the
'	Theodore William Bouskill. No other use is permitted without the express
'	prior written permission of Theodore William Bouskill. For permission,
'	contact copyright@bouskill.com"
'
Sub Main
	' Create preset variables
	str2Tabs = vbTab & vbTab
	str3Tabs = vbTab & vbTab & vbTab

	' The following two prefix strings can be modified to suit!	
	strFrmNamePrefix = "frm_"
	strFrmFieldPrefix = ""
	
	' Get an application object
	Set objApp = Application
	intSelectionLen = objApp.ActiveDocument.SelLength

	' If there is a valid selection
	If ( intSelectionLen > 0 ) Then
	
		' Retrieve the form name
		strFormName = strFrmNamePrefix & ConvertStrToVariableName(objApp.ActiveDocument.Lines(0))
	
		' Create the HTML head of the string
		strHTMLHead = "<form action="""" method=""post"" name=""" & strFormName & """>" & vbNewLine
		strHTMLHead = strHTMLHead & vbTab & "<table border=""0"" cellspacing=""0"" cellpadding=""0"">" & vbNewLine

		' Create the VBScript head of the string
		strVBHead = "<SCRIPT LANGUAGE=""JavaScript"">" & vbNewLine & vbTab & "<!--//" & vbNewLine
		strVBHead = strVBHead & str2Tabs & "objForm = new qForm(""" & strFormName & """);" & vbNewLine & vbNewLine
	
		' Build the string body for each line
		nbLines = objApp.ActiveDocument.LineCount
		
		' For each line following the first line
		For i = 1 To (nbLines - 1)
		
			' Append the row head
			strHTMLBody = strHTMLBody & str2Tabs & "<tr>" & vbNewLine

			' Save line for use
			strLine = Trim(objApp.ActiveDocument.Lines(i))
			
			' If the line is not empty
			If ( strLine <> "" ) Then
			
				' Build the first 2 columns
				strHTMLBody = strHTMLBody & str3Tabs & "<td>" & strLine & "</td>"
				strHTMLBody = strHTMLBody & "<td>&nbsp;</td>" & vbNewLine

				' Create the variable name
				strVarName = strFrmFieldPrefix & ConvertStrToVariableName(strLine)

				' Complete the 3rd column			
				strHTMLBody = strHTMLBody & str3Tabs & "<td><input name=""" & strVarName & """></td>" & vbNewLine

				' Build the VBScript line
				strVBBody = strVBBody & str2Tabs & "objForm." & strVarName & ".required = true;" & vbNewLine
				strVBBody = strVBBody & str2Tabs & "objForm." & strVarName & ".validateAlphaNumeric(""You have entered invalid characters, only letters and numbers please!"");" & vbNewLine

			else
			
				' If the line was blank use empty columns
				strHTMLBody = strHTMLBody & str3Tabs & "<tr><td colspan=""3"">&nbsp;</td></tr>" & vbNewLine
			
			end if
			
			' Append the row tail
			strHTMLBody = strHTMLBody & str2Tabs & "</tr>" & vbNewLine
		next
		
		' Build the last 2 rows
		strHTMLBody = strHTMLBody & str2Tabs & "<tr><td colspan=""3"">&nbsp;</td></tr>" & vbNewLine
		strHTMLBody = strHTMLBody & str2Tabs & "<tr>" & vbNewLine
		strHTMLBody = strHTMLBody & str3Tabs & "<td colspan=""3""><input type=""submit"" value=""Enter""></td>" & vbNewLine
		strHTMLBody = strHTMLBody & str2Tabs & "</tr>" & vbNewLine

		' Create the HTML tail of the string
		strHTMLTail = vbTab & "</table>" & vbNewLine
		strHTMLTail = strHTMLTail & "</form>" & vbNewLine

		' Create the VB tail of the string
		strVBTail = vbTab & "//-->" & vbNewLine & "</SCRIPT>"

		' Concatonate & assign
		strText = strHTMLHead & strHTMLBody & strHTMLTail
		strText = strText & strVBHead & strVBBody & strVBTail
		objApp.ActiveDocument.SelText = strText

	Else ' Invalid selection

		strMsg =  "This script requires a text selection to continue!"
	
		intReturn = objApp.MessageBox(strMsg, "frmBuilder: Syntax Error", MB_ICONINFORMATION)

	End If	

End Sub

Function ConvertStrToVariableName(strName)
	strVarName = replace(strName," ","")
	strVarName = LCase(Left(strVarName, 1)) & Right(strVarName, Len(strVarName)-1)
	ConvertStrToVariableName = strVarName
End Function
